module c_9_1(
   clk      ,
   rst_n    ,
   en       ,
   sio_c    ,
   sio_d     
);

input        clk      ;
input        rst_n    ;
input        en       ;
output       sio_c    ;
output       sio_d    ;


reg          sio_c    ;
reg          sio_d    ;
reg   [6:0]  cnt0     ;
wire         add_cnt0 ;
wire         end_cnt0 ;
reg   [5:0]  cnt1     ;
wire         add_cnt1 ;
wire         end_cnt1 ;
reg          flag_add ;
wire  [11:0] data     ;

always @(posedge clk or negedge rst_n)begin
    if(!rst_n)begin
        cnt0 <= 0;
    end
    else if(add_cnt0)begin
        if(end_cnt0)
            cnt0 <= 0;
        else
            cnt0 <= cnt0 + 1;
    end
end

assign add_cnt0 = flag_add;
assign end_cnt0 = add_cnt0 && cnt0==100-1 ;

always @(posedge clk or negedge rst_n)begin 
    if(!rst_n)begin
        cnt1 <= 0;
    end
    else if(add_cnt1)begin
        if(end_cnt1)
            cnt1 <= 0;
        else
            cnt1 <= cnt1 + 1;
    end
end

assign add_cnt1 = end_cnt0;
assign end_cnt1 = add_cnt1 && cnt1==12-1 ;
always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        flag_add <= 0;
    end
    else if(en)begin
        flag_add <= 1;
    end
    else if(end_cnt1)begin
        flag_add <= 0;
    end
end
always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        sio_c <= 1;
    end
    else if(add_cnt0 && cnt0==1-1 && cnt1!=0 && cnt1!=12-1)begin
        sio_c <= 0;
    end
    else if(add_cnt0 && cnt0==50-1)begin
        sio_c <= 1;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        sio_d <= 1;
    end
    else if(add_cnt0 && cnt0==25-1)begin
        sio_d <= data[11-cnt1];
    end
end

assign data = {1'b0,8'h5a,1'b1,1'b0,1'b1};








endmodule

